<?php
/*
 * Created on 6 Aug 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */

$uploadercal="/etc/raperca/uploader.ics";
if (isset($_POST["download"]) ){
	header("Content-type: text/calendar");
	echo file_get_contents($uploadercal);
	die();
}
$title="Pull Mode"; 
include ("prolog.php");

$spxNS = 'http://www.spinetix.com/namespace/1.0/spxconf';
$xlinkNS = 'http://www.w3.org/1999/xlink';

$config_name='/etc/raperca/uploaderconf.xml';

$config = new DOMDocument;
//$config->loadXML(file_get_contents($config_name));

$selectMode=-1;
$enable_project=0;
$project_source="";
$hourProj=$minProj=0;

$enable_log=0;
$logsource="";
$hourLog=$minLog=0;
$logs='accounting';
$icalsource="";
$icalsourceorig ="";
$checktime = "24h";
$input=$_POST;

if (isset($input["apply"]) ){
	$save=false;
	$config = new DOMDocument;
	$main=$config->appendChild($config->createElementNS($spxNS,'uploader'));
	
	switch ($input['selectMode']) {
		case -1:// disabled
			$proj=$main->appendChild($config->createElementNS($spxNS,'disabled'));
			$save=true;
		break;
		case 0:// manual setting
			$saveTime=-1;
			if (isset($input['enable_project'])){
				$proj=$main->appendChild($config->createElementNS($spxNS,'action'));
				$proj->setAttribute("summary", 'publish');
				$proj->setAttributeNS($xlinkNS,"xlink:href", $input['project_source']);
				$saveTime = $input['hourProj']*3600+$input['minProj']*60;
				$proj->setAttribute("time", $saveTime);
			}
			if (isset($input['enable_log'])){
				$proj=$main->appendChild($config->createElementNS($spxNS,'action'));
				$proj->setAttribute("summary", 'upload');
				$proj->setAttributeNS($xlinkNS,"xlink:href", $input['logsource']);
				$saveTime2 = $input['hourLog']*3600+$input['minLog']*60;
				if ( $saveTime2 == $saveTime ) 
					$saveTime2 += 5*60;
				$proj->setAttribute("time", $saveTime2);
				
				if (!isset($input['logs'])) $input['logs']='all';
				$proj->setAttribute("type", $input['logs']);
				if ($input['logs']=='accounting') {
					$desc=$proj->appendChild($config->createElementNS($spxNS,'desc'));
					$desc->appendChild($config->createTextNode("-accounting"));
				} else {
					$proj->setAttribute("type", "alllogs");
					$desc=$proj->appendChild($config->createElementNS($spxNS,'desc'));
					$desc->appendChild($config->createTextNode("-logs"));
				}
			}
			$save=true;
		break;
		case 1:// file
			 if (array_key_exists("new_file",$_FILES)){
				if ($_FILES["new_file"]["error"]>0 && $_FILES["new_file"]["name"]){
				     echo "<h3>Error:</h3>" . htmlspecialchars($_FILES["new_file"]["error"]) ." while uploading: ". htmlspecialchars($_FILES["new_file"]["name"]) ."<br />";
				}else {
					$ext=pathinfo($_FILES["new_file"]["name"]);
					if (!isset($ext["extension"])){
						echo "<h3>Error:</h3>No file selected<br />";
					} else if (strcasecmp("ics",$ext["extension"])==0){
						move_uploaded_file($_FILES["new_file"]["tmp_name"],$uploadercal);
						$save=true;
					}else{
					     echo "<h3>Error:</h3>" . htmlspecialchars($_FILES["new_file"]["name"]) ." is not an ics file<br />";
					}
				}
    		}
    		$proj=$main->appendChild($config->createElementNS($spxNS,'schedule'));
    		$proj->setAttributeNS($xlinkNS,"xlink:href", "uploader.ics");
    	break;
		case 2:// remote
			$proj=$main->appendChild($config->createElementNS($spxNS,'schedule'));
			$uri=preg_replace("@\[serial\]@",$serial, $input['icalsource']);
    		$proj->setAttributeNS($xlinkNS,"xlink:href", $uri);
    		if ( isset($input['check']) && $input['check']!="" ){
    			$time = timestr_to_secs($input['check']);
                if ( $time<10 ) $time = 10;
				$proj->setAttribute("check", $time);
			}
    		$save=true;
		break;
	}
	
	if ($save) {
		save_file($config_name,$config->saveXML());
		exec('/etc/init.d/uploader reload');
	} 
}

// load the config
$config = new DOMDocument;
$config->loadXML(file_get_contents($config_name));
$schedule=$config->getElementsByTagName("schedule");
if ($schedule->length>0) {
	$link=$schedule->item(0)->getAttributeNS($xlinkNS,"href");
	if ($link=="uploader.ics") {
		$selectMode = 1;
	} else {
		$selectMode = 2;
		$icalsourceorig=$link;
		$icalsource = preg_replace("@$serial@","[serial]",$link);
		$checktime = $schedule->item(0)->getAttribute("check");
		if ($checktime=="") $checktime="24h";
		else {
            $checktime = secs_to_timestr($checktime);
		}
	}
} else {
	// manual
	
	$proj=$config->getElementsByTagName("action");
	foreach ($proj as $action) {
		$name=$action->getAttribute("summary");
		if ($name=='publish') {
			$enable_project = 1;
			$project_source=$action->getAttributeNS($xlinkNS,"href");
			$time = $action->getAttribute("time");
			$hourProj=floor($time/3600);
			$minProj=floor(($time-$hourProj*3600)/60);
			$selectMode = 0;
		}
		if ($name=='upload') {
			$enable_log = 1;
			$logsource=$action->getAttributeNS($xlinkNS,"href");
			$time = $action->getAttribute("time");
			$hourLog=floor($time/3600);
			$minLog=floor(($time-$hourLog*3600)/60);
			$logs=$action->getAttribute("type");
			$selectMode = 0;
		}
	}
}
$logconf="/etc/raperca/uploaderlog.xml";
$logconfig = new DOMDocument;
$logconfig->loadXML(file_get_contents($logconf));

$priority=$logconfig->getElementsByTagName("priority");
if (isset($input["logapply"]) ){
	$priority->item(0)->setAttribute("value", $input["priority"]);
	save_file($logconf,$logconfig->saveXML());
}
$level = $priority->item(0)->getAttribute("value");
?>

<script type="text/javascript">
<!--

function selectCurrentMode(mode)
{
	document.getElementById("UploadProject").disabled = mode!=0;
	enableProject(mode);
	
	document.getElementById("UploadLogs").disabled = mode!=0;
	enableLogs(mode);
	
	document.getElementById("ScheduleFile").disabled = mode!=1;
	
	document.getElementById("ScheduleRemote").disabled = mode!=2;
	document.getElementById("ScheduleCheck").disabled = mode!=2;
	
}

function enableProject(mode)
{
	var enableProj=document.getElementById("UploadProject");

	document.getElementById("ProjectSource").disabled = mode!=0 || !enableProj.checked;
	document.getElementById("ProjHSelect").disabled = mode!=0 || !enableProj.checked;
	document.getElementById("ProjMSelect").disabled = mode!=0 || !enableProj.checked;
}

function enableLogs(mode)
{
	var enableLog=document.getElementById("UploadLogs");
	
	document.getElementById("LogSource").disabled = (mode!=0 || !enableLog.checked);
	document.getElementById("LogAccounting").disabled = mode!=0 || !enableLog.checked;
	document.getElementById("LogAll").disabled = mode!=0 || !enableLog.checked;
	document.getElementById("LogHSelect").disabled = mode!=0 || !enableLog.checked;
	document.getElementById("LogMSelect").disabled = mode!=0 || !enableLog.checked;
}

-->
</script>
<?php
echo "<h2>Content Pull Scheduling: </h2>\n";
echo "<form action='uploader.php' method='post' enctype='multipart/form-data'>\n";
echo "<table id='table'>\n";

print ("<tr><td colspan='2'><input type='radio' name='selectMode' value='-1' onclick='selectCurrentMode(-1)' ");
if ($selectMode==-1) print ("checked='checked' ");
echo " />&nbsp;Disabled</td></tr>\n";

print ("<tr><td colspan='2'><input type='radio' name='selectMode' value='0' onclick='selectCurrentMode(0)' ");
if ($selectMode==0) print ("checked='checked' ");
echo " />&nbsp;Manual settings</td></tr>\n";

echo "<tr><td style='width: 10%'/><td>\n";
$manualDisabled="";
$projectDisabled="";
$logDisabled="";
if ($selectMode!=0) $manualDisabled="disabled='disabled' ";

$checked="";
if ($enable_project) $checked = "checked='checked' ";
else $projectDisabled="disabled='disabled' ";

echo "<input type='checkbox' value='1' name='enable_project' $checked $manualDisabled id='UploadProject' onclick='enableProject(0)'/>Automatically upload project to the $product<br/>\n";
echo "<table>";
print "<tr><td>Project source: </td><td><input size='40' type='text' name='project_source' value=\"" . htmlspecialchars($project_source). "\" id='ProjectSource' $projectDisabled/></td></tr>\n";

echo "<tr><td>Time: </td><td><select name='hourProj' id='ProjHSelect' $projectDisabled>\n";
for ($i=0; $i<24; $i++){
	if ($i==$hourProj)
		echo "<option selected='selected' value='$i'>$i</option>";
	else 
		echo "<option value='$i'>$i</option>";
}
echo "</select>\n";
echo "<select name='minProj' id='ProjMSelect' $projectDisabled>\n";
for ($i=0; $i<60; $i+=5){
	if ($i==$minProj)
		echo "<option selected='selected' value='$i'>$i</option>";
	else 
		echo "<option value='$i'>$i</option>";
}
echo "</select></td></tr></table>\n";


$checked="";
if ($enable_log) $checked = "checked='checked' ";
else $logDisabled="disabled='disabled' ";

echo "<br/><input type='checkbox' value='1' name='enable_log' $checked $manualDisabled id='UploadLogs' onclick='enableLogs(0)' />Automatically upload logs from the $product<br/>\n";
echo "<table>";
print "<tr><td>Log destination: </td><td><input size='40' type='text' name='logsource' value=\"" . htmlspecialchars($logsource). "\" $logDisabled id='LogSource'/></td></tr>\n";



echo "<tr><td>Time: </td><td><select name='hourLog' id='LogHSelect' $logDisabled>\n";
for ($i=0; $i<24; $i++){
	if ($i==$hourLog)
		echo "<option selected='selected' value='$i'>$i</option>";
	else 
		echo "<option value='$i'>$i</option>";
}
echo "</select>\n";
echo "<select name='minLog' id='LogMSelect' $logDisabled>\n";
for ($i=0; $i<60; $i+=5){
	if ($i==$minLog)
		echo "<option selected='selected' value='$i'>$i</option>";
	else 
		echo "<option value='$i'>$i</option>";
}
echo "</select></td></tr>\n<tr><td/><td>";
if ( $logs=='accounting' ) {
	echo "<input type='radio' name='logs' value='accounting' $logDisabled id='LogAccounting' checked='checked'/>Accounting logs only\n";
	echo "<input type='radio' name='logs' value='all' $logDisabled id='LogAll'/>All logs</td></tr>\n";
} else {
	echo "<input type='radio' name='logs' value='accounting' $logDisabled id='LogAccounting'/>Accounting logs only\n";
	echo "<input type='radio' name='logs' value='all' $logDisabled id='LogAll' checked='checked'/>All logs</td></tr>\n";
}
echo "</table>\n";	

echo "</td></tr>\n";



print ("<tr><td colspan='2'><input type='radio' name='selectMode' value='1' onclick='selectCurrentMode(1)' ");
if ($selectMode==1) print ("checked='checked' ");
echo " />&nbsp;From uploaded iCalendar file (ics)</td></tr>\n";

$disabled="";
if ($selectMode!=1) $disabled="disabled='disabled' ";

echo "<tr><td/><td>";

echo "Schedule file: <input size='40' type='file' name='new_file' $disabled id='ScheduleFile'/><br/>\n";

if ($selectMode==1) {
	echo "<br/><input type='submit' value='See current schedule' name='download' /><br/>\n";
}

echo "</td></tr>\n";

print ("<tr><td colspan='2'><input type='radio' name='selectMode' value='2' onclick='selectCurrentMode(2)' ");
if ($selectMode==2) print ("checked='checked' ");
echo " />&nbsp;From remote iCalendar file (ics)</td></tr>\n";


$disabled="";
if ($selectMode!=2) $disabled="disabled='disabled' ";

echo "<tr><td/><td>";

print "Schedule uri: <input size='54' type='text' name='icalsource' value=\"" . htmlspecialchars($icalsource). "\" $disabled id='ScheduleRemote'/><br/>\n";
print "Check calendar every: <input size='10' type='text' name='check' value=\"" . htmlspecialchars($checktime). "\" $disabled id='ScheduleCheck'/><br/><br/>\n";
echo "Use '[serial]' in the URI to use the serial number of the $product<br/>";
print "<input size='67' type='text' disabled='disabled' value=\"". htmlspecialchars($icalsourceorig). "\"/><br/>\n";
echo "</td></tr>\n";


echo "</table>\n";
echo "<input type='submit' value='Apply' name='apply' />\n";
echo "</form>";
if ($advancedMode) {
	$trace=$debug=$info=$warning=$error=$fatal="";
	${$level}="selected='selected'";
	echo "<br/><h2>Log settings: </h2>\n";
	echo "<form action='uploader.php' method='post'><br/>\n";
	print("Level: <select name='priority' >");
	print("<option $trace value='trace'>Trace</option><option $debug value='debug'>Debug</option><option $info value='info'>Info</option>\n");
	print("<option $warning value='warn'>Warning</option><option $error value='error'>Error</option><option $fatal value='fatal'>Fatal</option>\n");
	print("</select>\n<br/><br/>\n");
	echo "<input type='hidden' value='1' name='advanced' />\n";
	echo "<input type='submit' value='Apply' name='logapply' />\n";
	echo "</form>";
}

include "final.php";

?>